// Written by TeTeT for Unsung

// Sample mission for an AC-47 fire support mission close to Khe Sanh village

uns_mbox_fnc_spooky = {
	systemChat "Calling spooky";
	params ["_target", "_caller", "_id"];
	// Only one action at a time
	_caller removeAction _id;
	private _fsPlaneClass = "uns_AC47" ;
	
	private _target = cursorObject;
	if (isNull _target) exitWith {
		systemChat "No target";
		_caller addAction [
			"Call AC-47 Spooky",
			"_this call uns_mbox_fnc_spooky"
		];
	};

	systemChat "Target identified";
	private _smokePos = getPos _target;
	private _smoke = createVehicle ["SmokeShellRed", _smokePos, [], 0, "NONE"];
	_smoke setPos [_smokePos select 0, _smokePos select 1, 5];
	_smoke setDamage 1;
	_caller sideChat "Target marked with red smoke";

	private _planeSpawnPos = _smoke getPos [2000, 135 + random 90];
	private _plane = createVehicle [_fsPlaneClass, _planeSpawnPos, [], 0, "FLY"];
	private _height = (getPosASL _smoke select 2) + 300;
	createVehicleCrew _plane;
	_plane setDir (_plane getDir _smoke);
	_plane setPosATL [getPos _plane select 0, getPos _plane select 1, _height];
	_plane flyInHeight 50;
	_plane flyInHeightASL [_height, _height, _height];

	systemChat "Spooky spawned";
	[_plane] spawn {
		params ["_plane"];
		private _mrkr = createMarker ["plane", getPos _plane];
		_mrkr setMarkerType "b_plane";
		_mrkr setMarkerColor "ColorBlue";
		while {alive _plane} do {
			sleep 0.1;
			_mrkr setMarkerPos (getPos _plane);
		};
		_mrkr setMarkerColor "ColorBlack";
		sleep 5;
		deleteMarker _mrkr;
	};

	private _grp = group driver _plane;

	private _wp = _grp addWaypoint [_target getPos [300, 0], 100];
	_wp setWaypointType "MOVE";
	_wp setWaypointSpeed "LIMITED";
	_wp = _grp addWaypoint [_target getPos [300, 270], 100];
	_wp setWaypointType "MOVE";
	_wp setWaypointSpeed "LIMITED";
	_wp = _grp addWaypoint [_target getPos [300, 180], 100];
	_wp setWaypointType "MOVE";
	_wp setWaypointSpeed "LIMITED";
	_wp = _grp addWaypoint [_target getPos [300, 90], 100];
	_wp setWaypointType "CYCLE";
	_wp setWaypointSpeed "LIMITED";

	(crew _plane) doWatch _target;

	// don't want to start shooting early
	while {_plane distance (_target getPos [300, 0]) > 500} do {
		sleep 1;
	};
	// debug
	// _plane setAmmo ["Uns_Triple_M134", 1000];
	while {alive _plane} do {
		if (_plane distance _target < 700) then {
			[_plane, "Uns_Triple_M134"] call BIS_fnc_fire;
		};
		if (_plane ammo "Uns_Triple_M134" isEqualTo 0) exitWith {
			_plane sideChat "Spooky RTB";
			while {(count (waypoints _grp)) > 0} do {
				deleteWaypoint ((waypoints _grp) select 0);
			};			
			_grp addWaypoint [_plane getPos [20000, random 360], 0];
			sleep 180;
			{_plane deleteVehicleCrew _x} forEach crew _plane;
			deleteVehicle _plane;
		};
		sleep 1;
	};
	_caller addAction [
		"Call AC-47 Spooky",
		"_this call uns_mbox_fnc_spooky"
	];

};

[] spawn {
	private _fac = FAC;
	_fac addAction [
		"Call AC-47 Spooky",
		"_this call uns_mbox_fnc_spooky"
	];
};